﻿using HarmonyLib;
using System.Collections;
using System.Linq;
using TMPro;
using UnityEngine;
using System.Reflection;


public class BetterItemDrops : Mod
{
    public static GameObject dropboxPrefab;
    AssetBundle asset;
    public static Shader shader;
    Harmony HARMONY_INSTANCE;
    string HARMONY_ID = "fr.tekgamer.betteritemdrops";

    public IEnumerator Start()
    {
        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("betteritemdrops.assets"));
        yield return request;
        asset = request.assetBundle;

        HARMONY_INSTANCE = new Harmony(HARMONY_ID);
        HARMONY_INSTANCE.PatchAll(Assembly.GetExecutingAssembly());

        dropboxPrefab = asset.LoadAsset<GameObject>("BetterDropBox");
        dropboxPrefab.AddComponent<BetterItemDrop>();
        Debug.Log("BetterItemDrops has been loaded!");
        shader = asset.LoadAsset<Material>("ExampleMaterial").shader;
        Traverse.Create(typeof(PickupObjectManager)).Field("dropboxPrefabStatic").SetValue(dropboxPrefab);
    }

    public override void WorldEvent_WorldLoaded()
    {
        Traverse.Create(typeof(PickupObjectManager)).Field("dropboxPrefabStatic").SetValue(dropboxPrefab);
    }
}

public class BetterItemDrop : MonoBehaviour
{
    public void Start()
    {
        PickupItem pickup = GetComponent<PickupItem>();
        Material m = new Material(BetterItemDrops.shader);
        m.mainTexture = pickup.itemInstance.settings_Inventory.Sprite.texture.name == "ItemIcons" ? GetTextureFromSprite(pickup.itemInstance.settings_Inventory.Sprite) : pickup.itemInstance.settings_Inventory.Sprite.texture;
        
        m.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.One);
        m.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);
        m.SetInt("_ZWrite", 0);
        m.DisableKeyword("_ALPHATEST_ON");
        m.DisableKeyword("_ALPHABLEND_ON");
        m.EnableKeyword("_ALPHAPREMULTIPLY_ON");
        m.renderQueue = 1000;

        transform.GetComponentsInChildren<Renderer>().ToList().ForEach((r) =>
        {
            if (r.gameObject.name != "model" && r.gameObject.name != "Text") { r.material = m; }
        });
        transform.GetComponentsInChildren<TextMeshPro>().ToList().ForEach((te) => te.text = "x" + pickup.itemInstance.Amount);
    }

    public Texture2D GetTextureFromSprite(Sprite sprite)
    {
        Texture2D nonReadable = sprite.texture;
        RenderTexture tmp = RenderTexture.GetTemporary(nonReadable.width, nonReadable.height, 0, RenderTextureFormat.Default, RenderTextureReadWrite.sRGB);
        Graphics.Blit(nonReadable, tmp);
        RenderTexture previous = RenderTexture.active;
        RenderTexture.active = tmp;
        Texture2D readable = new Texture2D(nonReadable.width, nonReadable.height);
        readable.ReadPixels(new Rect(0, 0, tmp.width, tmp.height), 0, 0);
        readable.Apply();
        RenderTexture.active = previous;
        RenderTexture.ReleaseTemporary(tmp);
        var croppedTexture = new Texture2D((int)sprite.rect.width, (int)sprite.rect.height);
        var pixels = readable.GetPixels((int)sprite.textureRect.x, (int)sprite.textureRect.y, (int)sprite.textureRect.width, (int)sprite.textureRect.height);
        if (croppedTexture.width != 64)
        {
            return GetTextureFromSprite(ItemManager.GetItemByIndex(236).settings_Inventory.Sprite);
        }
        croppedTexture.SetPixels(pixels);
        croppedTexture.Apply();
        return croppedTexture;

    }
}

[HarmonyPatch(typeof(PickupObjectManager))]
[HarmonyPatch("Start")]
class Patch_PickupObjectManager_Start
{
    static void Prefix(PickupObjectManager __instance)
    {
        Traverse.Create(typeof(PickupObjectManager)).Field("dropboxPrefabStatic").SetValue(BetterItemDrops.dropboxPrefab);
        Traverse.Create(__instance).Field("dropboxPrefab").SetValue(BetterItemDrops.dropboxPrefab);
    }
}